=== debian/changelog ===
libfiu (1.2-4build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 18 Oct 2025 13:23:10 +0000

libfiu (1.2-4) unstable; urgency=medium

  * Apply an upstream patch to fix FTBFS with GCC-15. (Closes: #1097184)

 -- Chris Lamb <lamby@debian.org>  Tue, 09 Sep 2025 17:05:31 -0700

libfiu (1.2-3) unstable; urgency=medium

  * Add explicit Build-Depends on python3-setuptools. (Closes: #1080632)
  * Bump Standards-Version to 4.7.0.

 -- Chris Lamb <lamby@debian.org>  Fri, 06 Sep 2024 12:36:56 +0100

libfiu (1.2-2) unstable; urgency=medium

  * Drop python3-distutils from Build-Depends. (Closes: #1065891)

 -- Chris Lamb <lamby@debian.org>  Mon, 11 Mar 2024 18:32:39 +0000

libfiu (1.2-1) unstable; urgency=medium

  * New upstream release.
    - Drop all local patches; applied upstream.

 -- Chris Lamb <lamby@debian.org>  Sat, 04 Nov 2023 10:18:26 +0100

libfiu (1.1-5) unstable; urgency=medium

  * Backport a patch (5dcc6d4) from upstream in order to fix test failure.
    (Closes: #1054777)
  * Bump Standards-Version to 4.6.2.

 -- Chris Lamb <lamby@debian.org>  Sun, 29 Oct 2023 12:11:33 +0000

libfiu (1.1-4) unstable; urgency=medium

  * Use dh_auto_clean to ensure package is properly cleaned. (Closes: #1048082)

 -- Chris Lamb <lamby@debian.org>  Tue, 22 Aug 2023 13:36:37 -0700
